<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 *
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author    D3 Data Development - Daniel Seifert <ds@shopmodule.com>
 * @link      http://www.oxidmodule.com
 */

class d3_remotelogin_update extends d3install_updatebase
{
    public $sModKey = 'd3_remote';
    public $sModName = 'Login as Customer';
    public $sModVersion = '2.1.1.0';
    public $sModRevision = '53';
    public $sBaseConf = 'U6mbHpCMnRwbWkvWHdzbzZ1enkvblI4bXJreWYvcmVuaytIeWpzNUFzRm5Yck1tMGl4VE5xM2hKR1hQQ
TNyNUFhbUQzUldIa1BtVS9Fa21ERmJkdXB6VER6clFWUUl0MExLNktuMzFlcnBVSERQZ0lhK2lreUI1Q
jNLbTdtaTZPVm80ZzExLy9TM01hUlZsOG9UckpjSUROUWpmK3VNVnFJQ3owa2JtUmxVMS9rY2tGYlpKS
05kUnVxTWFFalNoZWZBSUZmR2tmRG1QdDdxa2ZtbUI0Wk12Ym5rc0dpd3R1M25OUTRyTTNvWVp3UkV4Q
ko4cFI3NHpPQXE2clYxc01tQ3hPSnF6OEtKcS92TmpPQkN3MDVDMDhtQzlROHZXdGg1UVpuci9LYVRLN
m89';
    public $sRequirements = '<?xml version="1.0" encoding="UTF-8"?>
      <jobs>
        <registerModule>
          <module class="oxuser" modulepath="d3/d3_loginascustomer/modules/core/d3_oxuser_remotelogin" />
          <module class="oxcmp_user" modulepath="d3/d3_loginascustomer/modules/components/d3_oxcmp_user_remotelogin" />
          <module class="user_main" modulepath="d3/d3_loginascustomer/modules/controllers/admin/d3_user_main_remotelogin" />
        </registerModule>
      </jobs>';

    public $sBaseValue = '';

    protected $_aUpdateMethods = array(
        array('check' => 'checkModCfgItemExist',
              'do'    => 'updateModCfgItemExist'),
        array('check' => 'checkFields',
              'do'    => 'fixFields'),
        array('check' => 'checkModCfgSameRevision',
              'do'    => 'updateModCfgSameRevision'),
    );

    public $aFields = array
    (
        'D3LOGINASCUSTGROUP'      => array
        (
            'sTableName'  => 'oxgroups',
            'sFieldName'  => 'D3LOGINASCUSTGROUP',
            'sType'       => 'TINYINT(1)',
            'blNull'      => false,
            'sDefault'    => '0',
            'sComment'    => 'via login_as_customer signed in users in this session assigned group',
            'sExtra'      => '',
            'blMultilang' => false,
        ),
    );

    protected $_aRefreshMetaModuleIds = array('d3_loginascustomer');

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = FALSE;
        foreach ($this->getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet)
            {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = FALSE;

        if ($this->checkModCfgItemExist())
        {
            if (method_exists($this, '_setInitialExecMethod'))
                $this->_setInitialExecMethod(__METHOD__);

            foreach ($this->getShopList() as $oShop)
            {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid'       => $this->sModKey,
                    'oxshopid'      => $oShop->getId(),
                    'oxnewrevision' => $this->sModRevision,
                );

                if ($this->_checkTableItemNotExist('d3_cfg_mod', $aWhere))
                {
                    // update don't use this property
                    unset($aWhere['oxnewrevision']);

                    $aInsertFields = array(
                        'OXID'           => array (
                            'content'       => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                            'force_update'  => TRUE,
                            'use_quote'     => FALSE,
                        ),
                        'OXSHOPID'       => array (
                            'content'       => $oShop->getId(),
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXMODID'        => array (
                            'content'       => $this->sModKey,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXNAME'         => array (
                            'content'       => $this->sModName,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXACTIVE'       => array (
                            'content'       => "0",
                            'force_update'  => FALSE,
                            'use_quote'     => FALSE,
                        ),
                        'OXBASECONFIG'   => array (
                            'content'       => $this->sBaseConf,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXSERIAL'   => array (
                            'content'       => "",
                            'force_update'  => FALSE,
                            'use_quote'     => TRUE,
                        ),
                        'OXINSTALLDATE'  => array (
                            'content'       => "NOW()",
                            'force_update'  => TRUE,
                            'use_quote'     => FALSE,
                        ),
                        'OXVERSION'      => array (
                            'content'       => $this->sModVersion,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXSHOPVERSION'  => array (
                            'content'       => oxRegistry::getConfig()->getEdition(),
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXREQUIREMENTS' => array (
                            'content'       => $this->sRequirements,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        ),
                        'OXVALUE'        => array(
                            'content'       => $this->sBaseValue,
                            'force_update'  => FALSE,
                            'use_quote'     => TRUE,
                        ),
                        'OXNEWREVISION'  => array(
                            'content'       => $this->sModRevision,
                            'force_update'  => TRUE,
                            'use_quote'     => TRUE,
                        )
                    );

                    if (method_exists($this, '_updateTableItem2'))
                    {
                        $this->_setInitialExecMethod(__METHOD__);
                        $blRet  = $this->_updateTableItem2('d3_cfg_mod', $aInsertFields, $aWhere);
                    } else {  // bc
                        $aRet  = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                        $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                        $blRet = $aRet['blRet'];
                        $this->_setUpdateBreak(FALSE);
                    }
                }
            }
        }
        return $blRet;
    }
}